/////////////////////////////////////////////////////
// .value

// var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

function onUninstall(){

	if(! confirm("De-installeer deze extensie?")) return;
	var unreg = new exUnregisterer(	'chrome://quicknote/content/contents.rdf',
									'jar:%chromeFolder%quicknote.jar!/skin/classic/externalapp/contents.rdf',
									'jar:%chromeFolder%quicknote.jar!/locale/en-US/externalapp/contents.rdf');
	unreg.unregister();
	unreg.removePrefs('quicknote');
	window.close();
}


// On load of window (for new users will load first time )
// Makes sure the needed prefs are set on OK, and loads default values.

function loadQNSettings()
{
   
    // Set how many TABS (notes) are shown to the user (default are 2)
   if(!nsPreferences.getIntPref('quicknote.numtabs') || nsPreferences.getIntPref('quicknote.numtabs') == '0')
   {
	   document.getElementById('numtab-2').setAttribute('selected', true);
	   nsPreferences.setIntPref('quicknote.numtabs', 2);
	   document.getElementById('QNTabTwoFileB').collapsed = false;
	   document.getElementById('choose-tab2').collapsed = false;
   }else {
	   if(nsPreferences.getIntPref('quicknote.numtabs') == 2)
	   {
		   document.getElementById('numtab-2').setAttribute('selected', true);
		   document.getElementById('QNTabTwoFileB').collapsed = false;
		   document.getElementById('choose-tab2').collapsed = false;
	   }
	   if(nsPreferences.getIntPref('quicknote.numtabs') == 3)
	   {
		   document.getElementById('numtab-3').setAttribute('selected', true);
		   document.getElementById('QNTabTwoFileB').collapsed = false;
		   document.getElementById('QNTabThreeFileB').collapsed = false;
		   
		   document.getElementById('choose-tab2').collapsed = false;
		   document.getElementById('choose-tab3').collapsed = false;
	   }
	   if(nsPreferences.getIntPref('quicknote.numtabs') == 4)
	   {
		   //Show/Hide Tab File Boxes
		   document.getElementById('numtab-4').setAttribute('selected', true);
		   document.getElementById('QNTabTwoFileB').collapsed = false;
		   document.getElementById('QNTabThreeFileB').collapsed = false;
		   document.getElementById('QNTabFourFileB').collapsed = false;
		   
		   document.getElementById('choose-tab2').collapsed = false;
		   document.getElementById('choose-tab3').collapsed = false;
		   document.getElementById('choose-tab4').collapsed = false;
	   }
	   if(nsPreferences.getIntPref('quicknote.numtabs') == 1)
	   {
		   document.getElementById('numtab-1').setAttribute('selected', true);
	   }
    }	   
	   
   // ## Sets the "Send To.." options! And language support options. ##	
   if(!nsPreferences.getIntPref('quicknote.totabint') && !nsPreferences.getBoolPref('quicknote.langsupport') )
   {
   	nsPreferences.setIntPref('quicknote.totabint', '1');
	nsPreferences.setBoolPref('quicknote.langsupport', false);
	document.getElementById('choose-tab1').setAttribute('selected', true);
	
   }else{
	if (nsPreferences.getIntPref('quicknote.totabint') == 2)
	{
	    document.getElementById('choose-tab2').setAttribute('selected', true);
	}
	if (nsPreferences.getIntPref('quicknote.totabint') == 3)
	{
	    document.getElementById('choose-tab3').setAttribute('selected', true);
	}
	if (nsPreferences.getIntPref('quicknote.totabint') == 4)
	{
	    document.getElementById('choose-tab4').setAttribute('selected', true);
	}
	if (nsPreferences.getIntPref('quicknote.totabint') == 1)
	{
	    document.getElementById('choose-tab1').setAttribute('selected', true);
	}
	
	if (nsPreferences.getBoolPref('quicknote.langsupport') == true)
	{
	    document.getElementById('qn-LangEncoding').setAttribute('checked', true);
	}
   }
        // ## User Files Paths  ##
   	if ( !nsPreferences.getLocalizedUnicharPref('quicknote.tab1path') ){
		nsPreferences.setUnicharPref('quicknote.tab1path', "Blank");
		document.getElementById('QNTabOneFile').value =	nsPreferences.getLocalizedUnicharPref('quicknote.tab1path');
	}else{
		document.getElementById('QNTabOneFile').value =	nsPreferences.getLocalizedUnicharPref('quicknote.tab1path');
	}
	
	if ( !nsPreferences.getLocalizedUnicharPref('quicknote.tab2path') ){
		nsPreferences.setUnicharPref('quicknote.tab2path', "Blank");
		document.getElementById('QNTabTwoFile').value =	nsPreferences.getLocalizedUnicharPref('quicknote.tab2path');
	}else{
		document.getElementById('QNTabTwoFile').value =	nsPreferences.getLocalizedUnicharPref('quicknote.tab2path');
	}
	
	if ( !nsPreferences.getLocalizedUnicharPref('quicknote.tab3path') ){
		nsPreferences.setUnicharPref('quicknote.tab3path', "Blank");
		document.getElementById('QNTabThreeFile').value = nsPreferences.getLocalizedUnicharPref('quicknote.tab3path');
	}else{
		document.getElementById('QNTabThreeFile').value = nsPreferences.getLocalizedUnicharPref('quicknote.tab3path');
	}
	
	if ( !nsPreferences.getLocalizedUnicharPref('quicknote.tab4path') ){
		nsPreferences.setUnicharPref('quicknote.tab4path', "Blank");
		document.getElementById('QNTabFourFile').value = nsPreferences.getLocalizedUnicharPref('quicknote.tab4path');
	}else{
		document.getElementById('QNTabFourFile').value = nsPreferences.getLocalizedUnicharPref('quicknote.tab4path');
	}
	
	// ## Send to Text URL  ##
	if (nsPreferences.getBoolPref('quicknote.showUrl') == true)
	{
	    document.getElementById('qn-sendtotextUrl').setAttribute('checked', true);
	}
	
}

//On OK, sets the prefs chosen by the user.
function acceptQNSettings()
{
	if (document.getElementById('choose-tab2').getAttribute('selected') == 'true')
	{
		nsPreferences.setIntPref('quicknote.totabint', '2');
	}
	if (document.getElementById('choose-tab1').getAttribute('selected') == 'true'){
		nsPreferences.setIntPref('quicknote.totabint', '1');
	}
	if (document.getElementById('choose-tab3').getAttribute('selected') == 'true'){
		nsPreferences.setIntPref('quicknote.totabint', '3');
	}
	if (document.getElementById('choose-tab4').getAttribute('selected') == 'true'){
		nsPreferences.setIntPref('quicknote.totabint', '4');
	}
	
	if (document.getElementById('qn-LangEncoding').getAttribute('checked') == 'true')
	{
		nsPreferences.setBoolPref('quicknote.langsupport', true);
	}else{
		nsPreferences.setBoolPref('quicknote.langsupport', false);
	}
	
	var userTabOnepath = document.getElementById('QNTabOneFile').value;
	nsPreferences.setUnicharPref('quicknote.tab1path', userTabOnepath);
	
	var userTabTwopath = document.getElementById('QNTabTwoFile').value;
	nsPreferences.setUnicharPref('quicknote.tab2path', userTabTwopath);
	
	var userTabThreepath = document.getElementById('QNTabThreeFile').value;
	nsPreferences.setUnicharPref('quicknote.tab3path', userTabThreepath);
	
	var userTabFourpath = document.getElementById('QNTabFourFile').value;
	nsPreferences.setUnicharPref('quicknote.tab4path', userTabFourpath);
	
	if(!nsPreferences.getBoolPref('quicknote.firststart') || nsPreferences.getBoolPref('quicknote.firststart') == false){
		nsPreferences.setBoolPref('quicknote.firststart', true);
	}
	
	if (document.getElementById('qn-sendtotextUrl').getAttribute('checked') == 'true')
	{
		nsPreferences.setBoolPref('quicknote.showUrl', true);
	}else{
		nsPreferences.setBoolPref('quicknote.showUrl', false);
	}
	
	// ## Sets Number of Tabs ##
	if (document.getElementById('numtab-1').getAttribute('selected') == 'true')
	{
		nsPreferences.setIntPref('quicknote.numtabs', '1');
	}
	else if(document.getElementById('numtab-2').getAttribute('selected') == 'true')
	{
		nsPreferences.setIntPref('quicknote.numtabs', '2');
	}
	
	else if(document.getElementById('numtab-3').getAttribute('selected') == 'true')
	{
		nsPreferences.setIntPref('quicknote.numtabs', '3');
	}
	else if(document.getElementById('numtab-4').getAttribute('selected') == 'true')
	{
		nsPreferences.setIntPref('quicknote.numtabs', '4');
	}
	
	window.close();
}

//Show Hide tab prefs Dynamically!
function showHideTabPaths()
{
    if( document.getElementById('numtab-1').getAttribute('selected') )
    {
	   // ## User File box ##
	   document.getElementById('QNTabTwoFileB').collapsed = true;
	   document.getElementById('QNTabThreeFileB').collapsed = true;
	   document.getElementById('QNTabFourFileB').collapsed = true;
	   // ## Selected to. ##
	   document.getElementById('choose-tab2').collapsed = true;
	   document.getElementById('choose-tab3').collapsed = true;
	   document.getElementById('choose-tab4').collapsed = true;
    }
    if( document.getElementById('numtab-2').getAttribute('selected') )
    {
	   document.getElementById('QNTabTwoFileB').collapsed = false;
	   document.getElementById('QNTabThreeFileB').collapsed = true;
	   document.getElementById('QNTabFourFileB').collapsed = true;
	   
	    // ## Selected to. ##
	   document.getElementById('choose-tab2').collapsed = false;
	   document.getElementById('choose-tab3').collapsed = true;
	   document.getElementById('choose-tab4').collapsed = true;
    }
    if( document.getElementById('numtab-3').getAttribute('selected') )
    {
	   document.getElementById('QNTabTwoFileB').collapsed = false; 
	   document.getElementById('QNTabThreeFileB').collapsed = false;
	   document.getElementById('QNTabFourFileB').collapsed = true;
	   
	    // ## Selected to. ##
	   document.getElementById('choose-tab2').collapsed = false;
	   document.getElementById('choose-tab3').collapsed = false;
	   document.getElementById('choose-tab4').collapsed = true;
    }
    if( document.getElementById('numtab-4').getAttribute('selected') )
    {
	   document.getElementById('QNTabTwoFileB').collapsed = false; 
	   document.getElementById('QNTabThreeFileB').collapsed = false;
	   document.getElementById('QNTabFourFileB').collapsed = false;
	   
	    // ## Selected to. ##
	   document.getElementById('choose-tab2').collapsed = false;
	   document.getElementById('choose-tab3').collapsed = false;
	   document.getElementById('choose-tab4').collapsed = false;
    }
}

////////////////////////////////////////////////////////////////////////////////
// loaduserFile
//
// Desc: Loads the files by launching the FilePicker
// Parameters: targetNodeID: tab to which the file will be loaded
// Returns: false on error.
////////////////////////////////////////////////////////////////////////////////
function loaduserFile(targetNodeID) {
	var d = new DirUtils;
	var myUserDirPlease = d.getUserChromeDir();
	var targetNodeID2 = targetNodeID;
	var fName = txtFilePicker("Open a Text File",0,myUserDirPlease);
	if(fName==null){
	    document.getElementById(targetNodeID).value = "// File is invalid or does not exist..";
	    return false;
	}
	document.getElementById(targetNodeID).value = fName;
	alert("De browser of het QuickNote venster moeten worden herstart om de nieuwe bestanden te gebruiken.");
		
}

////////////////////////////////////////////////////////////////////////////////
// txtFilePicker
//
// Parameters:
//  aTitle: title to go on file picker window
//  aSave: 1 if picking file to save/overwrite, 0 if picking file to load
//  aStart: directory to start from
//    This must be an nsILocalFile.  new Dir("foo") in jslib/io/dir.js will
//    do the trick, but you have to do it yourself.
// Returns:
//  Name of file picked, in URL format, or null if cancelled
// Original taken and modified from Tagzilla.mozdev.org!
////////////////////////////////////////////////////////////////////////////////
function txtFilePicker(aTitle, aSave) {
  var retVal = null;
  try {
   
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    fp.init(window, aTitle, (aSave ? nsIFilePicker.modeSave : nsIFilePicker.modeOpen));
    fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);
    
    /*
    if(aStart) {
      fp.displayDirectory = aStart;
    }
    */
    var result=fp.show();
    if (result == nsIFilePicker.returnOK || result == nsIFilePicker.returnReplace) {
      //retVal=fp.fileURL.spec;
      retVal=fp.file.path;
      //alert("Should return retval: "+retVal+" YES!"); // DEBUG
    }
  }
  catch (ex) {
  }
  return retVal;
}
////////////
